#ifndef ASCIIFILE_HPP_INCLUDED
#define ASCIIFILE_HPP_INCLUDED

#include "Ctfscan.h"
#include "File.h"

#define BUFSIZE     256              /* size of read buffer */

class AsciiFile  : public File
{
public:
	AsciiFile(char* fname,           /* file name                          */
		char *blanks  = "\t", 
		char *fldseps = "\t",
		char *recseps = "\n",        /* record separators                  */
		bool load     = true,        /* flag for loading item sets         */
		bool isrec    = false        /* flag for one item set per record   */
);
	virtual ~AsciiFile(){}
private:
	ctfscan tfscan;                  /* table file scanner                 */
private:
	virtual void read_blk();         /* caches the dataset into memory     */
	virtual int get_item ();         /* --- read an item                   */
	virtual int get_iset ();         /* --- read an item set               */
//	void prepare ();                 /* --- sort set and remove duplicates */
protected:
	char            sid[BUFSIZE];    /* current set identifier             */
	char            buf[4*BUFSIZE];  /* read/write buffer                  */
	int             bufsid;          /* flag for buffered set id           */
	bool            isrec;           /* flag for one item set per record   */
};

#endif
