#ifndef CLUSTER_HPP_INCLUDED
#define CLUSTER_HPP_INCLUDED

#include <cmath>
#include <FastVector.h>
#include <AsciiFile.h>
#include "platform/hashmap.h"

/* the cluster class contains all the elements of the itemset belonging to the cluster  */
class Cluster : public hash_map<long,int,hash<long> >
{
// 	friend ostream& operator<<(ostream& s, Cluster& c){
//		return s;
//	}

protected:
	File* fp;                                   /* to print item names   */
public:
	virtual std::ostream& print(std::ostream& os, int n){
		return os;
	} 
	Cluster(){}
	long population;  /* the current population of the cluster                  */
	//vector<double> frequence;
	long act_population;                        /* the old population of the cluster                      */
	ITEMSET trlist;
public:
	double topten();
	virtual void set_representative(ITEMSET& e);
	virtual double distance(ITEMSET& e);
	virtual double setcoherence(ITEMSET& e);

	virtual void update(double gamma) 
    {
		act_population = population;            /* record the population                                  */
		population = 0;                         /* and reset the actual counter                           */
	}
	
	virtual void trash_update(){};
	inline void set_fileptr(File* f) // sets the cluster representative
    {      
		fp = f; // with a simple assignment
	}
};

#endif

