#ifndef CLUSTERGAMMA_HPP_INCLUDED
#define CLUSTERGAMMA_HPP_INCLUDED

#include "Cluster.h"

class ClusterGamma: public Cluster
{
//	friend ostream& operator<<(ostream& s, ClusterGamma& c);
protected:
	ITEMSET representative;                     /* contains items within itemsets with a significant frq  */                   
private:
	bool orderOutput;
	bool XMLFormat;
public:
	std::ostream& print(std::ostream& os, int n); 
	ClusterGamma(bool XMLf = false) { orderOutput = false; XMLFormat = XMLf; };
	double distance(ITEMSET& e);   	            /* compute the distance w.r.t. the cluster representative */
	double setcoherence(ITEMSET& e);   	      
	void update(double gamma);  /* updates the cluster representative having adequate frq */
	void trash_update();
	void set_representative(ITEMSET& e){ /* sets the cluster representative                        */
		representative = e;                     /* with a simple assignment                               */
	}
};


#endif
