#ifndef CTFSCAN_HPP_INCLUDED
#define CTFSCAN_HPP_INCLUDED

#include <cstdio>

/*----------------------------------------------------------------------
  Preprocessor Definitions
----------------------------------------------------------------------*/
/* --- character flags --- */
#define TFS_RECSEP   0x01       /* flag for record separator */
#define TFS_FLDSEP   0x02       /* flag for field separator */
#define TFS_BLANK    0x04       /* flag for blank character */
#define TFS_OTHER    0x08       /* flag for other character type */

/* --- delimiter types --- */
#define TFS_EOF      0          /* end of file delimiter */
#define TFS_REC      1          /* record delimiter */
#define TFS_FLD      2          /* field  delimiter */

class ctfscan  
{
public:
	ctfscan();
	virtual ~ctfscan   (){}
	ctfscan* tfs_dup   ();
	void    tfs_copy   (const ctfscan *src);
	int     tfs_sgetc  (const char *s);
	int     tfs_chars  (int type, const char *chars);
	void    tfs_istype (int type, int c);
	int     tfs_getfld (FILE* file,char *buf, int len, int *read);

/*----------------------------------------------------------------------
  Preprocessor Definitions
----------------------------------------------------------------------*/


protected:
	char cflags[256];

};


#define tfs_istype(t,c) (cflags[(unsigned char)(c)] & (t))


#endif

