#ifndef FAST_VECTOR_HPP_INCLUDED
#define FAST_VECTOR_HPP_INCLUDED

#include <algorithm>
#include <vector>
#include <functional>


struct ITEM
{  
    int  id;     /* item identifier */
    double  frq; /* frequency in item sets */
    char app;    /* appearance indicator */
};


struct frqcmp : public std::binary_function<ITEM*, ITEM*, bool> 
{
	bool operator()(const ITEM* x, const ITEM* y) { return (x->frq > y->frq); }
};

struct idcmp : public std::binary_function<ITEM*, ITEM*, bool> 
{
	bool operator()(const ITEM* x, const ITEM* y) { return (x->id < y->id); }
};

class ITEMSET: public std::vector<ITEM*>
{
	//friend ostream& operator<<(ostream& os,ITEMSET& T);
public:
	double distance(ITEMSET& v);
	void prepare();
    void outputsort();
};

#endif

