#ifndef RESULT_HPP_INCLUDED
#define RESULT_HPP_INCLUDED

#include <string>
#include "Kmeans.h"

class Result  
{
	//friend ostream& operator<<(ostream& os, Result& rs);
public:
	void 	setClasses(hash_map<std::string, int, hashString, eqstr> cl);
    Result::Result(Kmeans* a,bool mp = true, bool XMLf = false); 
	virtual ~Result(){}
public:
	std::ostream& print(std::ostream& os,int iteration); 
	//ostream& printH(ostream& os,int iteration); 
	std::string getDTS();             /* returns the Document Type Declaration of the output */
	hash_map<std::string, int, hashString, eqstr> classi;
protected:
	bool mapping;
	bool XMLFormat;
	Kmeans* algo;
};

inline std::string Result::getDTS()
{
	return "<?xml version=\"1.0\"?> \n \
			<!DOCTYPE experiment [\n \
			<!ELEMENT clustering		(cluster+,mapping,qualitymeasures)>\n \
			<!ELEMENT refinement		(cluster+,mapping,qualitymeasures)>\n \
			<!ELEMENT cluster      	(representative)>\n \
			<!ELEMENT representative	(item)*>\n \
			<!ELEMENT item 		EMPTY>\n \
			<!ELEMENT mapping		(assignment+)>\n \
			<!ELEMENT qualitymeasures (f-measure,Q1,Q2)>\n \
			<!ELEMENT f-measure 		EMPTY>\n \
			<!ELEMENT Q1 		EMPTY>\n \
			<!ELEMENT Q2 		EMPTY>\n \
			<!ELEMENT assignment		(tuple,class,clusterref)>\n \
			<!ELEMENT tuple		EMPTY>\n \
			<!ELEMENT class		EMPTY>\n \
			<!ELEMENT clusterref		EMPTY>\n \
			<!ATTLIST refinement refinement_id ID #REQUIRED>\n \
			<!ATTLIST cluster cluster_id ID #REQUIRED>\n \
			<!ATTLIST cluster population CDATA \"0\">\n \
			<!ATTLIST item id ID #REQUIRED>\n \
			<!ATTLIST item frequency CDATA \"0\">\n \
			<!ATTLIST tuple id ID #REQUIRED>\n \
			<!ATTLIST class id ID #REQUIRED>\n \
			<!ATTLIST clusterref id IDREF #REQUIRED>\n]>\n";
}
//<!ATTLIST clusterref id IDREF #REQUIRED>\n]>\n <experiment>\n<clustering>";
inline void Result::setClasses(hash_map<std::string, int, hashString, eqstr> cl){
	classi = cl;
}


#endif
