#ifndef RESOURCE_HPP_INCLUDED
#define RESOURCE_HPP_INCLUDED

#include <cstdio>
#include <cstdarg>
#include <cstdlib>

#define OK            0         /* no error */
#define E_NONE        0         /* no error */
#define E_NOMEM     (-1)        /* not enough memory */
#define E_FOPEN     (-2)        /* cannot open file */
#define E_FREAD     (-3)        /* read error on file */
#define E_FWRITE    (-4)        /* write error on file */
#define E_OPTION    (-5)        /* unknown option */
#define E_OPTARG    (-6)        /* missing option argument */
#define E_ARGCNT    (-7)        /* too few/many arguments */
#define E_STDIN     (-8)        /* double assignment of stdin */
#define E_SUPP      (-9)        /* invalid support */
#define E_CONF     (-10)        /* invalid confidence */
#define E_AREM     (-11)        /* invalid evaluation measure */
#define E_AREMVAL  (-12)        /* invalid value for measure */
#define E_RLEN     (-13)        /* invalid rule length */
#define E_SIDEXP   (-14)        /* set id expected */
#define E_ITEMEXP  (-15)        /* item expected */
#define E_DUPITEM  (-16)        /* duplicate item */
#define E_FLDCNT   (-17)        /* too many fields */
#define E_UNKAPP   (-18)        /* unknown appearance indicator */
#define E_INPUT	   (-19)        /* Invalid input type */
#define E_MAPPING  (-20)        /* Quality measures without mapping */
#define E_ALGO	   (-21)        /* Invalid algorithm type */
#define E_FXML     (-22)        /* error reading XML file */
#define E_UNKNOWN  (-23)        /* unknown error */




extern const char *errmsgs[];

#define VERSION     "version 3.0 (10.10.2001) (c) 1997-2001   Giuseppe Manco, Cristian Gozzi\n"

void error (int code,...);
void msg (const char *fmt, ...);


#endif
